Package net.sf.saxon.serialize.codenorm

## Class NormalizerData

- java.lang.Object
- - net.sf.saxon.serialize.codenorm.NormalizerData

-     public class NormalizerData
      extends java.lang.Object

  Accesses the Normalization Data used for Forms C and D.

  Copyright (c) 1998-1999 Unicode, Inc. All Rights Reserved.
  The Unicode Consortium makes no expressed or implied warranty of any kind, and assumes no liability for errors or omissions. No liability is assumed for incidental and consequential damages in connection with or arising out of the use of the information here.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `NOT_COMPOSITE` | Constant for use in getPairwiseComposition

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `getCanonicalClass​(int ch)` | Gets the combining class of a character from the Unicode Character Database.
    `char` | `getPairwiseComposition​(int first, int second)` | Returns the composite of the two characters.
    `void` | `getRecursiveDecomposition​(boolean canonical, int ch, FastStringBuffer buffer)` | Gets recursive decomposition of a character from the Unicode Character Database.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NOT_COMPOSITE

          public static final int NOT_COMPOSITE

      Constant for use in getPairwiseComposition
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getCanonicalClass

          public int getCanonicalClass​(int ch)

      Gets the combining class of a character from the Unicode Character Database.
      Parameters:
        `ch` - the source character
      Returns:
        value from 0 to 255

    - #### getPairwiseComposition

          public char getPairwiseComposition​(int first,
                                             int second)

      Returns the composite of the two characters. If the two characters don't combine, returns NOT_COMPOSITE. Only has to worry about BMP characters, since those are the only ones that can ever compose.
      Parameters:
        `first` - first character (e.g. 'c')
        `second` - second character (e.g. '�' cedilla)
      Returns:
        composite (e.g. '�')

    - #### getRecursiveDecomposition

          public void getRecursiveDecomposition​(boolean canonical,
                                                int ch,
                                                FastStringBuffer buffer)

      Gets recursive decomposition of a character from the Unicode Character Database.
      Parameters:
        `canonical` - If true bit is on in this byte, then selects the recursive canonical decomposition, otherwise selects the recursive compatibility and canonical decomposition.
        `ch` - the source character
        `buffer` - buffer to be filled with the decomposition